package clients;

import roads.State;

import org.jgrapht.graph.DefaultDirectedGraph;
import org.jgrapht.graph.DefaultDirectedWeightedGraph;

import roads.Location;
import roads.Street;

public class Metropolis 
{

	public static Location a = new Location("a",10.0);
	public static Location b = new Location("b",10.0);
	public static Location c = new Location("c",10.0);
	public static Location d = new Location("d",10.0);
	public static Location e = new Location("e",10.0);
	public static Location f = new Location("f",10.0);

	public static Location supply = a;
	public static Location emergency = e;


	
	
	private static void addEdge(DefaultDirectedWeightedGraph<Location, Street> graph,Location source, Location dest,double p,double c)
	{
		
		Street s = new Street(p);
		graph.addEdge(source, dest, s);
		graph.setEdgeWeight(s,c);
		
		Street bi = new Street(p);
		graph.addEdge(dest, source, bi);
		graph.setEdgeWeight(bi,c);
		
	}
	
	
	public static State cityModel()
	{
		State city = new State(6);
		
		DefaultDirectedWeightedGraph<Location, Street> graph = new
				DefaultDirectedWeightedGraph<Location, Street>(Street.class);

		city.locations[0] = a;
		city.locations[1] = b;
		city.locations[2] = c;
		city.locations[3] = d;
		city.locations[4] = e;
		city.locations[5] = f;

		city.supply = Metropolis.supply;
		city.dispatch = Metropolis.emergency;
		
		city.graph = graph;
		for(int i=0;i<city.locations.length;i++)
		{
			graph.addVertex(city.locations[i]);
		}
		addEdge(graph,a,b,0.90,2);
		addEdge(graph,a,c,0.97,5);		
		addEdge(graph,a,d,0.98,9);
		addEdge(graph,b,c,0.93,1);		
		addEdge(graph,c,e,0.98,4);				
		addEdge(graph,d,c,0.98,6);
		addEdge(graph,d,f,0.97,3);		
		addEdge(graph,e,f,0.98,8);				
		addEdge(graph,f,c,0.90,7);
		
		city.name = "metropolis";

		return city;

	}

}
