package clients;

import java.util.Random;

import org.jgrapht.generate.GnmRandomGraphGenerator;
import org.jgrapht.graph.DefaultDirectedGraph;
import org.jgrapht.util.SupplierUtil;

import roads.State;
import roads.Location;
import roads.Planner;
import roads.Street;

public class RandomGraphs {


	public static State generateRandAbstractModel(int n,int m,Location current,Location destination)
	{
		State am = null;
		Planner plan = new Planner(am);
		boolean hasRoute=false;
		while(!hasRoute)
		{
			am = RandomGraphs.randomAbstractModel(n, m);

			hasRoute = plan.sp.getPath(current, destination).getLength()==0;			
		}
		return am;
	}


	private  static int locationIndex(Location[] locations,Location l)
	{

		for(int i=0;i<locations.length;i++)
		{
			if(locations[i] == l)
			{
				return i;
			}
		}

		return -1;

	}

	public static State randomAbstractModel(int n,int m)
	{
		DefaultDirectedGraph<Location, Street> graph = randomGraph(n,m);

		State city = new State(n);

		city.graph = graph;
		int count=0;
		for(Location l : graph.vertexSet())
		{
			city.locations[count++] = l;									
		}


		city.supply = city.locations[0];
		city.dispatch = city.locations[n-1];

		city.name = "RandomTown";


		/*for(Street street : graph.edgeSet())
		{

			//	System.out.println(street);		
			double p = street.getProbability();
			double c =  street.getWeight();
			int i = locationIndex(city.locations,street.getSource());
			int j = locationIndex(city.locations,street.getTarget());

			//city.adj[i][j]=true;
			//city.prob[i][j]=p;
			//city.cost[i][j]=c;
			//city.bi(city.adj, i, j, true);
			//city.bi(city.prob,i,j, p);
			//city.bi(city.cost,i,j, c);
		}
		//city.initGraph();
*/		return city;
	}


	private static DefaultDirectedGraph<Location, Street> randomGraph(int n,int m)
	{
		DefaultDirectedGraph<Location, Street> graph = 
				new DefaultDirectedGraph<Location,Street>(
						SupplierUtil.createSupplier(Location.class),
						SupplierUtil.createSupplier(Street.class)
						,false);

		GnmRandomGraphGenerator rg = new GnmRandomGraphGenerator(n,m);

		rg.generateGraph(graph);

		return graph;

	}
	//------
	public static void main(String[] args) {


		//DefaultDirectedGraph<Location, Street>  graph = RandomGraphs.randomGraph(200, 5);
		randomAbstractModel(10,5);


	}

}
