package roads;





import parser.ast.ModulesFile;
import parser.ast.PropertiesFile;
import prism.Model;
import prism.Prism;
import prism.PrismException;
import prism.PrismFileLog;

import prism.PrismLog;

import verification.RoadModel;
import verification.RoadProperty;
import verification.RoadResult;


public class Verification 
{
	
	public static String experimentOutput = "/Users/kjohnson/Documents/Professional/Research/SEAMS-2020/scale";
	public Prism prism;
	public PrismLog prismMainLog;

	
	
	public Verification() throws Exception
	{
		this.prismMainLog = new PrismFileLog("PrismLogFile.txt");
		prism = new Prism(this.prismMainLog);
		prism.initialise();
	}
	

	public RoadResult verify(RoadModel model,RoadProperty...properties) 
	{
		
		RoadResult r = new RoadResult();
		try {

			ModulesFile modulesFile;
			PropertiesFile propertiesFile;

			modulesFile = prism.parseModelString(model.body);
			//System.out.println(model.body);
			
			prism.loadPRISMModel(modulesFile);
			prism.buildModelIfRequired();
			//System.out.println(model.body);
			//Random rand = new Random();
			//int index = rand.nextInt();
			//RoadsTest.writefile(experimentOutput+"scaleoutput"+index+".txt", model.body);
			
			
			for(RoadProperty property : properties)
			{
				propertiesFile = prism.parsePropertiesString(modulesFile,property.formula);			
				prism.Result fromPrismResult = prism.modelCheck(propertiesFile, propertiesFile.getPropertyObject(0));
				Model prismModel = prism.getBuiltModel();
			//	r.numberOfStates = prismModel.getNumStates();
			//	r.numberOfTransitions = prismModel.getNumTransitions();
		//		r.description = fromPrismResult.getExplanation();				
				r.results.put(property, fromPrismResult);
				
			}
			return r;


		} catch (PrismException e) {

			System.out.println(model.body);
			e.printStackTrace();
		}
		return null;
	}





}
